const Main    = imports.ui.main;
const Shell   = imports.gi.Shell;
const GLib    = imports.gi.GLib;
const Meta    = imports.gi.Meta;
const Gio     = imports.gi.Gio;
const Utils   = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const mySettings = Utils.getSettings();
const key_bindings = 	{	'toggle-nautilus': function() {_toggleNautilus(0);},
				'toggle-nautilus1': function() {_startApplication(1);},
				'toggle-nautilus2': function() {_startApplication(2);},
				'toggle-nautilus3': function() {_startApplication(3);},
				'toggle-nautilus4': function() {_startApplication(4);},
				'toggle-nautilus5': function() {_startApplication(5);}
			};

const WA_FOLDER = 'default-folder';
const WA_FOLDER1 = 'folder1';
const WA_FOLDER2 = 'folder2';
const WA_FOLDER3 = 'folder3';
const WA_FOLDER4 = 'folder4';
const WA_FOLDER5 = 'folder5';

var dt = new Date();

function _toggleNautilus(num) {

	let win = _getWindowActor();

	// Start nautilus + block run new nautilus windows during 1s
	if (win === 'start') {
		if (new Date().getTime() > dt.getTime() ){
			dt.setTime( new Date().getTime() + 1000 );
			_startApplication(num);
			return;
		}				
	}

        if (!win) {
		dt.setTime( new Date().getTime() + 100 );
		return;
        }
        // minimize/unmaximize + 200ms between 2 minimize call
	if (win.has_focus()){
       		if (win.minimized) {
			win.unminimize();
			win.activate(global.get_current_time());
			dt.setTime( new Date().getTime() + 200 );
       		} else {
			if (new Date().getTime() > dt.getTime() ){
				dt.setTime( new Date().getTime() + 200 );
				win.minimize();
			}
         	}
	} else {
		win.unminimize();
		win.activate(global.get_current_time());
		dt.setTime( new Date().getTime() + 200 );
	}


}

function _startApplication(num){
        let folder = this.mySettings.get_string(WA_FOLDER);
        if (num >= 1) { folder = this.mySettings.get_string(WA_FOLDER1);}
        if (num >= 2) { folder = this.mySettings.get_string(WA_FOLDER2);}
        if (num >= 3) { folder = this.mySettings.get_string(WA_FOLDER3);}
        if (num >= 4) { folder = this.mySettings.get_string(WA_FOLDER4);}
        if (num >= 5) { folder = this.mySettings.get_string(WA_FOLDER5);}
	global.log(folder);
	imports.misc.util.trySpawnCommandLine('/usr/bin/nautilus ' + folder);
	//imports.misc.util.trySpawnCommandLine('/usr/bin/nemo ' + folder);
}

function _getWindowActor(){
	let ApplicationString = _("nautilus.desktop");
	//let ApplicationString = _("nemo.desktop");
	let window =Shell.AppSystem.get_default().lookup_app(ApplicationString).get_windows()[0];
	if(typeof window == 'undefined') { window = 'start';}
	return window;
}

function init(meta) {
	Utils.initTranslations("toggle_nautilus@kirby33");
}

function enable() {
	dt.setTime(dt.getTime());
	let key;	
	for(key in key_bindings) 
	{
		if (Main.wm.addKeybinding && Shell.KeyBindingMode) 
		{ 
			Main.wm.addKeybinding(key,mySettings,Meta.KeyBindingFlags.NONE, Shell.KeyBindingMode.NORMAL | Shell.KeyBindingMode.MESSAGE_TRAY,key_bindings[key]); 
		}
		else if (Main.wm.addKeybinding && Main.KeybindingMode) 
		{
			Main.wm.addKeybinding(key,mySettings,Meta.KeyBindingFlags.NONE,Main.KeybindingMode.NORMAL | Main.KeybindingMode.MESSAGE_TRAY, key_bindings[key]);
		} 
		else 
		{
			global.display.add_keybinding(key,mySettings,Meta.KeyBindingFlags.NONE,key_bindings[key]); 
		}
	}
}

function disable() {
	let key;
	for(key in key_bindings) {
		global.display.remove_keybinding(key);
	}
}
